package MT::Plugin::EntryBlock;
use strict;
use MT;
use MT::Plugin;
use MT::Entry;

our $VERSION = '0.1';

use base qw( MT::Plugin );

@MT::Plugin::EntryBlock::ISA = qw( MT::Plugin );

my $plugin = new MT::Plugin::EntryBlock( {
    id   => 'EntryBlock',
    key  => 'entryblock',
    name => 'EntryBlock',
    description => 'Search entry and set the entry context.',
    version => $VERSION,
    author_name => 'Junnama Noda',
    author_link => 'http://junnama.alfasado.net/online/',
} );

MT->add_plugin( $plugin );

sub init_registry {
    my $plugin = shift;
    $plugin->registry( {
        tags => {
            block => {
                'EntryBlock' => \&_entry_block,
            },
        },
   } );
}

sub _entry_block {
    my ( $ctx, $args, $cond ) = @_;
    my $key = $args->{ key };
    my $value = $args->{ value };
    my $e = MT::Entry->load({ $key => $value });
    local $ctx->{ __stash }{ entry } = $e if $e;
    my $tokens = $ctx->stash( 'tokens' );
    my $builder = $ctx->stash( 'builder' );
    my $out = $builder->build( $ctx, $tokens, $cond );
}

1;